/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the GetChannelMediaCenterFiles200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetChannelMediaCenterFiles200Response{}

// GetChannelMediaCenterFiles200Response struct for GetChannelMediaCenterFiles200Response
type GetChannelMediaCenterFiles200Response struct {
	Results []MediaCenterFile `json:"results,omitempty"`
	Total *int32 `json:"total,omitempty"`
}

// NewGetChannelMediaCenterFiles200Response instantiates a new GetChannelMediaCenterFiles200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetChannelMediaCenterFiles200Response() *GetChannelMediaCenterFiles200Response {
	this := GetChannelMediaCenterFiles200Response{}
	return &this
}

// NewGetChannelMediaCenterFiles200ResponseWithDefaults instantiates a new GetChannelMediaCenterFiles200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetChannelMediaCenterFiles200ResponseWithDefaults() *GetChannelMediaCenterFiles200Response {
	this := GetChannelMediaCenterFiles200Response{}
	return &this
}

// GetResults returns the Results field value if set, zero value otherwise.
func (o *GetChannelMediaCenterFiles200Response) GetResults() []MediaCenterFile {
	if o == nil || IsNil(o.Results) {
		var ret []MediaCenterFile
		return ret
	}
	return o.Results
}

// GetResultsOk returns a tuple with the Results field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetChannelMediaCenterFiles200Response) GetResultsOk() ([]MediaCenterFile, bool) {
	if o == nil || IsNil(o.Results) {
		return nil, false
	}
	return o.Results, true
}

// HasResults returns a boolean if a field has been set.
func (o *GetChannelMediaCenterFiles200Response) HasResults() bool {
	if o != nil && !IsNil(o.Results) {
		return true
	}

	return false
}

// SetResults gets a reference to the given []MediaCenterFile and assigns it to the Results field.
func (o *GetChannelMediaCenterFiles200Response) SetResults(v []MediaCenterFile) {
	o.Results = v
}

// GetTotal returns the Total field value if set, zero value otherwise.
func (o *GetChannelMediaCenterFiles200Response) GetTotal() int32 {
	if o == nil || IsNil(o.Total) {
		var ret int32
		return ret
	}
	return *o.Total
}

// GetTotalOk returns a tuple with the Total field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetChannelMediaCenterFiles200Response) GetTotalOk() (*int32, bool) {
	if o == nil || IsNil(o.Total) {
		return nil, false
	}
	return o.Total, true
}

// HasTotal returns a boolean if a field has been set.
func (o *GetChannelMediaCenterFiles200Response) HasTotal() bool {
	if o != nil && !IsNil(o.Total) {
		return true
	}

	return false
}

// SetTotal gets a reference to the given int32 and assigns it to the Total field.
func (o *GetChannelMediaCenterFiles200Response) SetTotal(v int32) {
	o.Total = &v
}

func (o GetChannelMediaCenterFiles200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetChannelMediaCenterFiles200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Results) {
		toSerialize["results"] = o.Results
	}
	if !IsNil(o.Total) {
		toSerialize["total"] = o.Total
	}
	return toSerialize, nil
}

type NullableGetChannelMediaCenterFiles200Response struct {
	value *GetChannelMediaCenterFiles200Response
	isSet bool
}

func (v NullableGetChannelMediaCenterFiles200Response) Get() *GetChannelMediaCenterFiles200Response {
	return v.value
}

func (v *NullableGetChannelMediaCenterFiles200Response) Set(val *GetChannelMediaCenterFiles200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableGetChannelMediaCenterFiles200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableGetChannelMediaCenterFiles200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetChannelMediaCenterFiles200Response(val *GetChannelMediaCenterFiles200Response) *NullableGetChannelMediaCenterFiles200Response {
	return &NullableGetChannelMediaCenterFiles200Response{value: val, isSet: true}
}

func (v NullableGetChannelMediaCenterFiles200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetChannelMediaCenterFiles200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


